use Cache::Memcached;
use Cache::Memcached::Fast;
use Cache::Memcached::libmemcached;
use Benchmark qw/cmpthese/;

my $n = 50000;
my $max = 500;
my @keys = map { "x" . $_ } 0..$max;

my $pp = Cache::Memcached->new( { 
    servers => ['127.0.0.1:11211']
} );
my $fast = Cache::Memcached::Fast->new( {
    servers => ['127.0.0.1:11211']
} );
my $lib = Cache::Memcached::libmemcached->new( {
    servers => ['127.0.0.1:11211']
} );

$pp->add( $_ => rand ) for @keys;
foreach my $num ( qw/1 5 10 100/ ) {
    print "### $num\n";
    my @keys = map { "x" . $_ } 0..$num;
    cmpthese(
        $n => {
            pp => sub {
                $pp->get_multi(@keys);
            },
            fast => sub {
                $fast->get_multi(@keys);
            },
            lib => sub {
                $lib->get_multi(@keys);
            },

        }
    );
}
