#include <stdio.h>
#include <string.h>

#include "libmemcached/memcached.h"

int main(int argc, char **argv)
{
    struct memcached_st *memc;
    struct memcached_server_st *servers;
    memcached_return rc;
    char *keys[]= {"foo", "bar", "baz", "hoge"};
    size_t keys_length[] = {3, 3, 3, 4};
    unsigned int num_of_keys = 3;
    int i;

    memc = memcached_create(NULL);
    servers = memcached_servers_parse("127.0.0.1:11211");
    if((rc = memcached_server_push(memc, servers)) != MEMCACHED_SUCCESS) {
        fprintf(stderr, "Error: %s\n", memcached_strerror(memc, rc));
        return -1;
    }
    for(i = 0; i < num_of_keys; i++) {
        if((rc = memcached_set(memc, keys[i], keys_length[i], keys[i], keys_length[i], 0, 0)) != MEMCACHED_SUCCESS) {
            fprintf(stderr, "Error: %s\n", memcached_strerror(memc, rc));
            return -1;
        }
    }
    rc = memcached_mget(memc, keys, keys_length, num_of_keys);
    if(rc == MEMCACHED_SUCCESS) {
        char key[MEMCACHED_MAX_KEY];
        char *value;
        size_t key_length, value_length;
        uint32_t flags;
        while((value = memcached_fetch(memc, key, &key_length,
                                       &value_length, &flags, &rc)) != NULL) {
            printf("%s\n", value);
        }
        if(value)
            free(value);
    }

    memcached_server_list_free(servers);
    memcached_free(memc);
}
